package Team5.SmartTowns;

import static org.hamcrest.Matchers.containsString;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors;

@SpringBootTest
@AutoConfigureMockMvc
@ActiveProfiles("dev")
public class ContainerMockMVCTests {
    @Autowired
    private MockMvc mockMvc;

//    todo have to test
    @Test
    public void a_testGreeting() throws Exception {
        this.mockMvc.perform(get("/home")).andDo(print()).andExpect(status().isOk())
                .andExpect(content().string(containsString("VZTA Smart Towns - Trails")));
    }

    @Test
    public void a_testGreeting2() throws Exception {
        this.mockMvc.perform(get("/mobile-home")).andDo(print()).andExpect(status().isOk())
                .andExpect(content().string(containsString("Welcome to VZTA Smart Towns!")));
    }


    @Test
    public void a_testGreeting3() throws Exception {
        this.mockMvc.perform(get("/towns/Caerphilly")).andDo(print()).andExpect(status().isOk())
                .andExpect(content().string(containsString("Caerphilly Trails")));
    }


    @Test
    public void a_testGreeting4() throws Exception {
        this.mockMvc.perform(get("/mobile-home").with(SecurityMockMvcRequestPostProcessors.user("Admin").roles("ADMIN")))
                .andDo(print())
                .andExpect(content().string(containsString("Review Landmark!")));


    }




}

